"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _LocaleLink = require("../LocaleLink");

var _react2 = require("@testing-library/react");

var __jsx = _react["default"].createElement;
// MOCK <Link /> component for shallow rendering
jest.mock("next/link", function () {
  return jest.fn(function (props) {
    return __jsx("span", props, props.children);
  });
});
describe("<LocaleLink />", function () {
  var context = {
    locale: {
      country: "id",
      language: "id"
    },
    defaultLocale: "id-id",
    siteLocales: ["id-id", "en-id"],
    router: {
      pathname: "/"
    }
  };
  it("should render <Link /> to navigate from default locale", function () {
    var _render = (0, _react2.render)(__jsx(_LocaleLink.LocaleLink, (0, _extends2["default"])({}, context, {
      href: "/about"
    }), __jsx("a", null, "Tentang"))),
        container = _render.container;

    expect(container).toMatchSnapshot();
  });
  it("should render <Link /> to navigate from non-default locale", function () {
    var locale = {
      language: "en",
      country: "id"
    };

    var _render2 = (0, _react2.render)(__jsx(_LocaleLink.LocaleLink, (0, _extends2["default"])({}, context, {
      href: "/about",
      locale: locale
    }), __jsx("a", null, "About"))),
        container = _render2.container;

    expect(container).toMatchSnapshot();
  });
  it("should render <Link /> to navigate to custom route", function () {
    var _render3 = (0, _react2.render)(__jsx(_LocaleLink.LocaleLink, (0, _extends2["default"])({}, context, {
      as: "p/hello-world",
      href: "/post?title=Hello World"
    }), __jsx("a", null, "Hello World"))),
        container = _render3.container;

    expect(container).toMatchSnapshot();
  });
  it("should render <Link /> to navigate to another locale", function () {
    var locale = {
      language: "en",
      country: "id"
    };

    var _render4 = (0, _react2.render)(__jsx(_LocaleLink.LocaleLink, (0, _extends2["default"])({}, context, {
      locale: locale
    }), __jsx("a", null, "English (Indonesia)"))),
        container = _render4.container;

    expect(container).toMatchSnapshot();
  });
  it("should accept locale object", function () {
    var _render5 = (0, _react2.render)(__jsx(_LocaleLink.LocaleLink, (0, _extends2["default"])({}, context, {
      locale: {
        language: "en",
        country: "sg"
      },
      href: "/about"
    }), __jsx("a", null, "About"))),
        container = _render5.container;

    expect(container).toMatchSnapshot();
  });
});