"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _reactCookie = require("react-cookie");

var _withCookiesPage = _interopRequireDefault(require("../withCookiesPage"));

var _react2 = require("@testing-library/react");

var __jsx = _react["default"].createElement;
describe("withCookiesPage", function () {
  var Page, PageWithCookies;
  beforeEach(function () {
    Page = function Page(props) {
      expect(props).toMatchSnapshot();
      return __jsx(_react["default"].Fragment, null, props.init ? __jsx("div", {
        "data-testid": "props-init"
      }, "init") : __jsx(_react["default"].Fragment, null));
    };

    Page.getInitialProps = function () {
      return {
        init: true
      };
    };

    PageWithCookies = (0, _withCookiesPage["default"])(Page);
  });
  afterEach(function () {
    delete process.browser;
  });
  describe("browser", function () {
    beforeEach(function () {
      process.browser = true;
    });
    it("should add cookie to page props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var props, _render, findByTestId, propsInit;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return PageWithCookies.getInitialProps({});

            case 2:
              props = _context.sent;
              _render = (0, _react2.render)(__jsx(PageWithCookies, (0, _extends2["default"])({}, props, {
                cookies: new _reactCookie.Cookies()
              }))), findByTestId = _render.findByTestId;
              _context.next = 6;
              return findByTestId("props-init");

            case 6:
              propsInit = _context.sent;
              expect(propsInit).toBeTruthy();

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
  });
  describe("server", function () {
    beforeEach(function () {
      process.browser = false;
    });
    it("should add cookie to page props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var props, _render2, findByTestId, propsInit;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              global.MOCK_IS_NODE = true;
              _context2.next = 3;
              return PageWithCookies.getInitialProps({
                req: {
                  universalCookies: new _reactCookie.Cookies("key=value")
                }
              });

            case 3:
              props = _context2.sent;
              _render2 = (0, _react2.render)(__jsx(PageWithCookies, props)), findByTestId = _render2.findByTestId;
              _context2.next = 7;
              return findByTestId("props-init");

            case 7:
              propsInit = _context2.sent;
              expect(propsInit).toBeTruthy();
              delete global.MOCK_IS_NODE;

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    })));
  });
});