"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _withLocaleComponent = _interopRequireDefault(require("../withLocaleComponent"));

var _LocaleProvider = _interopRequireDefault(require("../../components/LocaleProvider"));

var _react2 = require("@testing-library/react");

var __jsx = _react["default"].createElement;
describe("withLocale", function () {
  var context, Component, ComponentWithLocale;
  beforeEach(function () {
    context = {
      locale: {
        language: "id",
        country: "id"
      },
      defaultLocale: "id-id",
      siteLocales: ["id-id", "en-id"]
    };

    Component = function Component(props) {
      expect(props).toMatchSnapshot();
      return __jsx("div", {
        "data-testid": "component-locale"
      });
    };

    ComponentWithLocale = (0, _withLocaleComponent["default"])(Component);
  });
  it("should add default locale, locale, and site locales to component props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var _render, findByTestId, componentLocale;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _render = (0, _react2.render)(__jsx(_LocaleProvider["default"], context, __jsx(ComponentWithLocale, null))), findByTestId = _render.findByTestId;
            _context.next = 3;
            return findByTestId("component-locale");

          case 3:
            componentLocale = _context.sent;
            expect(componentLocale).toBeTruthy();

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  it("should override locale context with locale props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    var locale, _render2, findByTestId, componentLocale;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            locale = {
              language: "en",
              country: "id"
            };
            _render2 = (0, _react2.render)(__jsx(_LocaleProvider["default"], context, __jsx(ComponentWithLocale, {
              locale: locale
            }))), findByTestId = _render2.findByTestId;
            _context2.next = 4;
            return findByTestId("component-locale");

          case 4:
            componentLocale = _context2.sent;
            expect(componentLocale).toBeTruthy();

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it("should accept locale string props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    var _render3, findByTestId, componentLocale;

    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _render3 = (0, _react2.render)(__jsx(_LocaleProvider["default"], context, __jsx(ComponentWithLocale, {
              locale: "en-id"
            }))), findByTestId = _render3.findByTestId;
            _context3.next = 3;
            return findByTestId("component-locale");

          case 3:
            componentLocale = _context3.sent;
            expect(componentLocale).toBeTruthy();

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
});