"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _withLocalePage = _interopRequireDefault(require("../withLocalePage"));

var _react2 = require("@testing-library/react");

var __jsx = _react["default"].createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

describe("withLocalePage", function () {
  var context, commonProps, Page, PageWithLocale;
  beforeEach(function () {
    commonProps = {
      asPath: "/",
      query: {}
    };
    context = {
      locale: {
        language: "id",
        country: "id"
      },
      defaultLocale: "id-id",
      siteLocales: ["id-id", "en-id"]
    };

    Page = function Page(props) {
      expect(props).toMatchSnapshot();
      return __jsx("div", {
        "data-testid": "component-locale"
      });
    };

    Page.getInitialProps = function () {
      return {
        init: true
      };
    };

    PageWithLocale = (0, _withLocalePage["default"])(Page);
  });
  describe("server", function () {
    it("should add default locale, locale, and site locales to page props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var props, _render, findByTestId, componentLocale;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return PageWithLocale.getInitialProps(_objectSpread(_objectSpread({}, commonProps), {}, {
                req: context
              }));

            case 2:
              props = _context.sent;
              _render = (0, _react2.render)(__jsx(PageWithLocale, props)), findByTestId = _render.findByTestId;
              _context.next = 6;
              return findByTestId("component-locale");

            case 6:
              componentLocale = _context.sent;
              expect(componentLocale).toBeTruthy();

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
  });
  describe("browser", function () {
    beforeEach(function () {
      process.browser = true;
    });
    afterEach(function () {
      delete process.browser;
    });
    it("should add default locale, locale, and site locales to page props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var props, _render2, findByTestId, componentLocale;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              window.__NEXT_DATA__ = {
                props: context
              };
              _context2.next = 3;
              return PageWithLocale.getInitialProps(commonProps);

            case 3:
              props = _context2.sent;
              _render2 = (0, _react2.render)(__jsx(PageWithLocale, props)), findByTestId = _render2.findByTestId;
              _context2.next = 7;
              return findByTestId("component-locale");

            case 7:
              componentLocale = _context2.sent;
              expect(componentLocale).toBeTruthy();

            case 9:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    })));
    it("should update locale if supported", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      var props, _render3, findByTestId, componentLocale;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              window.__NEXT_DATA__ = {
                props: context
              };
              _context3.next = 3;
              return PageWithLocale.getInitialProps(_objectSpread(_objectSpread({}, commonProps), {}, {
                query: {
                  locale: "en-id"
                }
              }));

            case 3:
              props = _context3.sent;
              _render3 = (0, _react2.render)(__jsx(PageWithLocale, props)), findByTestId = _render3.findByTestId;
              _context3.next = 7;
              return findByTestId("component-locale");

            case 7:
              componentLocale = _context3.sent;
              expect(componentLocale).toBeTruthy();

            case 9:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    })));
    it("should not update locale if unsupported", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      var props, _render4, findByTestId, componentLocale;

      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              window.__NEXT_DATA__ = {
                props: context
              };
              _context4.next = 3;
              return PageWithLocale.getInitialProps(_objectSpread(_objectSpread({}, commonProps), {}, {
                query: {
                  locale: "en-sg"
                }
              }));

            case 3:
              props = _context4.sent;
              _render4 = (0, _react2.render)(__jsx(PageWithLocale, props)), findByTestId = _render4.findByTestId;
              _context4.next = 7;
              return findByTestId("component-locale");

            case 7:
              componentLocale = _context4.sent;
              expect(componentLocale).toBeTruthy();

            case 9:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    })));
  });
});