"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.createReduxPageFactory = void 0;

var _redux = require("redux");

var _createBasePage = _interopRequireDefault(require("./createBasePage"));

var _withReduxStore = _interopRequireDefault(require("./withReduxStore"));

var _createConfigureStore = _interopRequireDefault(require("../redux/createConfigureStore"));

var createReduxPageFactory = function createReduxPageFactory(configureStore) {
  return function (reducers) {
    for (var _len = arguments.length, connectArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      connectArgs[_key - 1] = arguments[_key];
    }

    return (0, _redux.compose)(_createBasePage["default"], (0, _withReduxStore["default"])(configureStore).apply(void 0, [reducers].concat(connectArgs)));
  };
};

exports.createReduxPageFactory = createReduxPageFactory;

var _default = createReduxPageFactory((0, _createConfigureStore["default"])());

exports["default"] = _default;