"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.withApolloClientFactory = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _head = _interopRequireDefault(require("next/head"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _reactApollo = require("react-apollo");

var _withClient = _interopRequireDefault(require("../apollo/withClient"));

var _Statics = require("../constants/Statics");

var __jsx = _react["default"].createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var withApolloClientFactory = function withApolloClientFactory() {
  var enhancer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function (Page) {
    return Page;
  };
  var rootContext = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (ctx) {
    return {};
  };
  var ssr = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return function (configureClient) {
    return function (Page) {
      var EnhancedPage = enhancer((0, _hoistNonReactStatics["default"])(function (_ref) {
        var client = _ref.client,
            props = (0, _objectWithoutProperties2["default"])(_ref, ["client"]);
        return __jsx(_reactApollo.ApolloProvider, {
          client: client
        }, __jsx(Page, props));
      }, Page));

      if (!ssr) {
        return (0, _withClient["default"])(configureClient)(EnhancedPage);
      }

      var WithApolloClient = /*#__PURE__*/function (_React$Component) {
        (0, _inherits2["default"])(WithApolloClient, _React$Component);

        var _super = _createSuper(WithApolloClient);

        function WithApolloClient() {
          (0, _classCallCheck2["default"])(this, WithApolloClient);
          return _super.apply(this, arguments);
        }

        (0, _createClass2["default"])(WithApolloClient, [{
          key: "render",
          value: function render() {
            return __jsx(EnhancedPage, this.props);
          }
        }], [{
          key: "getInitialProps",
          value: function () {
            var _getInitialProps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(ctx) {
              var props, url, app;
              return _regenerator["default"].wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.t0 = EnhancedPage.getInitialProps;

                      if (!_context.t0) {
                        _context.next = 5;
                        break;
                      }

                      _context.next = 4;
                      return EnhancedPage.getInitialProps(ctx);

                    case 4:
                      _context.t0 = _context.sent;

                    case 5:
                      props = _context.t0;

                      if (process.browser) {
                        _context.next = 19;
                        break;
                      }

                      if (!(ctx.res && ctx.res.finished)) {
                        _context.next = 9;
                        break;
                      }

                      return _context.abrupt("return");

                    case 9:
                      // Provide the `url` prop data in case a graphql query uses it
                      url = {
                        query: ctx.query,
                        pathname: ctx.pathname
                      };
                      _context.prev = 10;
                      // Run all GraphQL queries
                      app = __jsx(EnhancedPage, (0, _extends2["default"])({
                        client: ctx.client,
                        url: url
                      }, props));
                      _context.next = 14;
                      return (0, _reactApollo.getDataFromTree)(app, _objectSpread(_objectSpread({}, rootContext(ctx)), {}, {
                        router: {
                          query: ctx.query,
                          pathname: ctx.pathname,
                          asPath: ctx.asPath
                        }
                      }));

                    case 14:
                      _context.next = 18;
                      break;

                    case 16:
                      _context.prev = 16;
                      _context.t1 = _context["catch"](10);

                    case 18:
                      // getDataFromTree does not call componentWillUnmount
                      // head side effect therefore need to be cleared manually
                      _head["default"].rewind();

                    case 19:
                      return _context.abrupt("return", props);

                    case 20:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, null, [[10, 16]]);
            }));

            function getInitialProps(_x) {
              return _getInitialProps.apply(this, arguments);
            }

            return getInitialProps;
          }()
        }]);
        return WithApolloClient;
      }(_react["default"].Component);

      return (0, _withClient["default"])(configureClient)((0, _hoistNonReactStatics["default"])(WithApolloClient, EnhancedPage, _Statics.NEXT_STATICS));
    };
  };
};

exports.withApolloClientFactory = withApolloClientFactory;

var _default = withApolloClientFactory();

exports["default"] = _default;