"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _applyReducers = _interopRequireDefault(require("../applyReducers"));

var _react2 = require("@testing-library/react");

var _reactRedux = require("react-redux");

var __jsx = _react["default"].createElement;
describe("applyReducers", function () {
  var context, Component, ComponentWithProvider, ReducersAppliedComponent;
  var reducers = {
    unique: jest.fn()
  };

  var createMockStore = function createMockStore() {
    var soya = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
    return {
      addReducer: jest.fn(),
      dispatch: jest.fn(),
      getState: jest.fn(),
      replaceReducer: jest.fn(),
      soya: soya,
      subscribe: jest.fn()
    };
  };

  beforeEach(function () {
    context = {
      store: createMockStore()
    };

    Component = function Component() {
      return __jsx("div", null);
    };

    Component.getInitialProps = function () {
      return {
        init: true
      };
    };

    ReducersAppliedComponent = (0, _applyReducers["default"])(reducers)(Component);

    ComponentWithProvider = function ComponentWithProvider() {
      return __jsx(_reactRedux.Provider, {
        store: context.store
      }, __jsx(ReducersAppliedComponent, null));
    };
  });
  it("should throw error if store is not using soya enhancer", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return ReducersAppliedComponent.getInitialProps({
              store: createMockStore(false)
            });

          case 3:
            _context.next = 8;
            break;

          case 5:
            _context.prev = 5;
            _context.t0 = _context["catch"](0);
            expect(_context.t0.message).toBe("applyReducers must be used with Soya's redux enhancer");

          case 8:
            context.store = createMockStore(false);
            expect(function () {
              (0, _react2.render)(__jsx(ComponentWithProvider, null));
            }).toThrow("applyReducers must be used with Soya's redux enhancer");

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 5]]);
  })));
  it("should return as is if no arguments is specified", function () {
    expect((0, _applyReducers["default"])()(Component)).toEqual(Component);
  });
  it("should apply reducers in getInitialProps lifecycle", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    var addReducerMock, props;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            addReducerMock = context.store.addReducer.mock;
            _context2.next = 3;
            return ReducersAppliedComponent.getInitialProps(context);

          case 3:
            props = _context2.sent;
            expect(addReducerMock.calls.length).toBe(1);
            expect(Object.keys(addReducerMock.calls[0][0])).toEqual(["unique"]);
            expect(props.init).toBeTruthy();

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it("should apply reducers in constructor", function () {
    var addReducerMock = context.store.addReducer.mock;
    (0, _react2.render)(__jsx(ComponentWithProvider, null));
    expect(addReducerMock.calls.length).toBe(1);
    expect(Object.keys(addReducerMock.calls[0][0])).toEqual(["unique"]);
  });
});