"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _createConfigureStore = _interopRequireDefault(require("../createConfigureStore"));

describe("createConfigureStore", function () {
  it("should create basic configureStore", function () {
    var configureStore = (0, _createConfigureStore["default"])();
    var store = configureStore();
    store.replaceReducer({
      local: function local() {
        var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        return state;
      }
    });
    expect(store.getState()).toMatchSnapshot();
  });
  it("should create configureStore with global reducers", function () {
    var configureStore = (0, _createConfigureStore["default"])({
      global: function global() {
        var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return state;
      }
    });
    var store = configureStore({});
    store.replaceReducer({
      local: function local() {
        var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        return state;
      }
    });
    expect(store.getState()).toMatchSnapshot();
  });
});