"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _redux = require("redux");

var _middleware = _interopRequireDefault(require("../middleware"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

jest.useFakeTimers();
describe("Middleware", function () {
  var store;

  var thunk = function thunk(_ref) {
    var dispatch = _ref.dispatch,
        getState = _ref.getState;
    return function (next) {
      return function (action) {
        return typeof action === "function" ? action(dispatch, getState) : next(action);
      };
    };
  };

  var fetchData = function fetchData() {
    return /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(dispatch) {
        var res;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return new Promise(function (resolve) {
                  setTimeout(function () {
                    resolve({
                      data: true
                    });
                  }, 1000);
                });

              case 2:
                res = _context.sent;
                dispatch(_objectSpread({
                  type: "FETCH_DATA"
                }, res));

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }();
  };

  var fetchDataSoya = function fetchDataSoya() {
    return {
      type: "FETCH_DATA_SOYA",
      soya: {
        load: function load() {
          return new Promise(function (resolve) {
            setTimeout(function () {
              resolve({
                data: true
              });
            }, 1000);
          });
        }
      }
    };
  };

  var reducer = function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var action = arguments.length > 1 ? arguments[1] : undefined;

    switch (action.type) {
      case "FETCH_DATA":
        if (action.data) {
          return state.concat(state.length);
        }

        return state;

      case "FETCH_DATA_SOYA":
        if (action.soya.data) {
          return state.concat(state.length);
        }

        return state;

      default:
        return state;
    }
  };

  beforeEach(function () {
    store = (0, _redux.applyMiddleware)(thunk, _middleware["default"])(_redux.createStore)(reducer);
  });
  it("should throw an error if non-string query id", function () {
    expect(function () {
      store.dispatch({
        type: "NON_STRING_QUERY_ID",
        soya: {
          id: []
        }
      });
    }).toThrow("Expected soya action id to be a string.");
  });
  it("should throw an error if load is not a function", function () {
    expect(function () {
      store.dispatch({
        type: "NON_FUNCTION_LOAD",
        soya: {
          id: "1",
          load: "function"
        }
      });
    }).toThrow("Expected soya action load to be a function.");
  });
  it("should dispatch action normally", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return new Promise(function (resolve) {
              for (var i = 1; i <= 5; i++) {
                store.dispatch(fetchData());
                jest.runTimersToTime(i * 200);
              }

              jest.runAllTimers();
              resolve();
            });

          case 2:
            expect(store.getState().length).toBe(5);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  it("should only dispatch once per query id per running request", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return new Promise(function (resolve) {
              for (var i = 1; i <= 5; i++) {
                store.dispatch(fetchDataSoya());
                jest.runTimersToTime(i * 200);
              }

              jest.runAllTimers();
              resolve();
            });

          case 2:
            expect(store.getState().length).toBe(1);

          case 3:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
});