"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _createConfigureStore = _interopRequireDefault(require("../createConfigureStore"));

var _withStore = _interopRequireDefault(require("../withStore"));

var _react2 = require("@testing-library/react");

var __jsx = _react["default"].createElement;
describe("withStore", function () {
  var Page, PageWithStore;
  beforeEach(function () {
    Page = function Page(props) {
      return __jsx(_react["default"].Fragment, null, props.store ? __jsx("div", {
        "data-testid": "props-store"
      }, "store") : __jsx(_react["default"].Fragment, null), props.init ? __jsx("div", {
        "data-testid": "props-init"
      }, "init") : __jsx(_react["default"].Fragment, null));
    };

    Page.getInitialProps = function () {
      return {
        init: true
      };
    };

    PageWithStore = (0, _withStore["default"])((0, _createConfigureStore["default"])())(Page);
  });
  afterEach(function () {
    delete process.browser;
  });
  describe("browser", function () {
    beforeEach(function () {
      process.browser = true;
    });
    it("should add store to page props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var props, _render, findByTestId, propsStore, propsInit;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return PageWithStore.getInitialProps({});

            case 2:
              props = _context.sent;
              _render = (0, _react2.render)(__jsx(PageWithStore, (0, _extends2["default"])({}, props, {
                store: {
                  soya: true
                }
              }))), findByTestId = _render.findByTestId;
              _context.next = 6;
              return findByTestId("props-store");

            case 6:
              propsStore = _context.sent;
              _context.next = 9;
              return findByTestId("props-init");

            case 9:
              propsInit = _context.sent;
              expect(propsStore).toBeTruthy();
              expect(propsInit).toBeTruthy();

            case 12:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
  });
  describe("server", function () {
    beforeEach(function () {
      process.browser = false;
    });
    it("should add store to page props", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var props, _render2, findByTestId, propsStore, propsInit;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              delete global.Window;
              _context2.next = 3;
              return PageWithStore.getInitialProps({});

            case 3:
              props = _context2.sent;
              _render2 = (0, _react2.render)(__jsx(PageWithStore, props)), findByTestId = _render2.findByTestId;
              _context2.next = 7;
              return findByTestId("props-store");

            case 7:
              propsStore = _context2.sent;
              _context2.next = 10;
              return findByTestId("props-init");

            case 10:
              propsInit = _context2.sent;
              expect(propsStore).toBeTruthy();
              expect(propsInit).toBeTruthy();

            case 13:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    })));
  });
});