"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _getDisplayName = _interopRequireDefault(require("../utils/getDisplayName"));

var _Statics = require("../constants/Statics");

var _reactRedux = require("react-redux");

var __jsx = _react["default"].createElement;

var _default = function _default(reducers) {
  return function (Component) {
    if (typeof reducers === "undefined") {
      return Component;
    }

    function ApplyReducers(props) {
      var flag = _react["default"].useRef(true);

      var context = _react["default"].useContext(_reactRedux.ReactReduxContext);

      var store = props.store || context.store;

      if (flag.current) {
        if (!store.soya) {
          throw new Error("applyReducers must be used with Soya's redux enhancer");
        }

        store.addReducer(reducers);
        flag.current = false;
      }

      return __jsx(Component, props);
    }

    ApplyReducers.displayName = (0, _getDisplayName["default"])("applyReducers", Component);

    ApplyReducers.getInitialProps = /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(ctx) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (ctx.store.soya) {
                  _context.next = 2;
                  break;
                }

                throw new Error("applyReducers must be used with Soya's redux enhancer");

              case 2:
                ctx.store.addReducer(reducers);
                _context.t0 = Component.getInitialProps;

                if (!_context.t0) {
                  _context.next = 8;
                  break;
                }

                _context.next = 7;
                return Component.getInitialProps(ctx);

              case 7:
                _context.t0 = _context.sent;

              case 8:
                return _context.abrupt("return", _context.t0);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    return (0, _hoistNonReactStatics["default"])(ApplyReducers, Component, _Statics.NEXT_STATICS);
  };
};

exports["default"] = _default;