"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _url = require("url");

var _default = function _default() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      defaultLocale = _ref.defaultLocale,
      siteLocales = _ref.siteLocales;

  if (typeof defaultLocale !== "string") {
    throw new Error("Expected defaultLocale to be a locale string.");
  }

  if (typeof siteLocales !== "object" || siteLocales.constructor !== Array || siteLocales.length === 0) {
    throw new Error("Expected siteLocales to be an array of locale string.");
  }

  return function (req, res, next) {
    var _defaultLocale$split = defaultLocale.split("-"),
        _defaultLocale$split2 = (0, _slicedToArray2["default"])(_defaultLocale$split, 2),
        language = _defaultLocale$split2[0],
        country = _defaultLocale$split2[1];

    var _parseUrl = (0, _url.parse)(req.url),
        pathname = _parseUrl.pathname;

    var _pathname$substr$spli = pathname.substr(1).split("/"),
        _pathname$substr$spli2 = (0, _slicedToArray2["default"])(_pathname$substr$spli, 1),
        localeSegment = _pathname$substr$spli2[0];

    if (localeSegment) {
      var _localeSegment$split = localeSegment.split("-"),
          _localeSegment$split2 = (0, _slicedToArray2["default"])(_localeSegment$split, 2),
          languageSegment = _localeSegment$split2[0],
          _localeSegment$split3 = _localeSegment$split2[1],
          countrySegment = _localeSegment$split3 === void 0 ? country : _localeSegment$split3;

      if (siteLocales.indexOf("".concat(languageSegment, "-").concat(countrySegment)) !== -1) {
        country = countrySegment;
        language = languageSegment;
        req.url = req.url.substr(localeSegment.length + 1) || "/";
      }
    }

    req.defaultLocale = defaultLocale;
    req.siteLocales = siteLocales;
    req.locale = {
      country: country,
      language: language
    };
    next();
  };
};

exports["default"] = _default;